<?php
function webmail_plus_admin($type = 'list') {
	die('dead');
}


function webmail_plus_admin_settings() {

	$form = array();

	// notify the user that he needs to select a connection
	$connection = variable_get('webmail_plus_connection', NULL);
	if(!$connection) drupal_set_message('No connection is selected. Make sure to select the default connection.', 'warning');


	$servers = mail_api_get_servers();




	if(sizeof($servers)>0) {
    	foreach($servers as $server_id => $server_info) {
    		//if($server_info->suspended==1) continue;
    		$connections[$server_info['domain']]=$server_info['domain'];
    	}
	}
	else {
	  drupal_set_message('No mail servers were configured. Please use Mail API to configure servers.');
	}

	if(sizeof($servers)>0) {
      // Server settings
      $form['server'] = array(
      	'#type' => 'fieldset',
          '#title' => t('Mail Storage'),
          '#collapsible' => TRUE,
          '#collapsed' => TRUE
      );

      $form['server']['webmail_plus_connection'] = array(
      	'#type' => 'radios',
          '#title' => t('Mail Connection'),
          '#default_value' => variable_get('webmail_plus_connection', NULL),
          '#options' => $connections,
          '#description' => t('Select the connection which will be used by Webmail Plus to provide email storage.')
      );

      // presentation
      $form['presentation'] = array(
      	'#type' => 'fieldset',
          '#title' => t('Presentation'),
          '#collapsible' => TRUE,
          '#collapsed' => TRUE
      );

      $form['presentation']['webmail_plus_thread_messages'] = array(
      	'#type' => 'checkbox',
          '#title' => t('Group similar messages into conversations'),
          '#default_value' => variable_get('webmail_plus_thread_messages', TRUE),
          '#description' => t('Message replies will be organized into a coversation.')
      );

      // user settings
      $form['user'] = array(
      	'#type' => 'fieldset',
          '#title' => t('User Settings'),
          '#collapsible' => TRUE,
          '#collapsed' => TRUE
      );

      $form['user']['webmail_plus_user_signature'] = array(
      	'#type' => 'checkbox',
          '#title' => t('Allow user signatures'),
          '#default_value' => variable_get('webmail_plus_user_signature', TRUE),
          '#description' => t('Check this if you want users to use their signatures in outbound emails.')
      );

      $form['user']['webmail_plus_user_out_of_office'] = array(
      	'#type' => 'checkbox',
          '#title' => t('Allow out of office response'),
          '#default_value' => variable_get('webmail_plus_user_out_of_office', NULL),
          '#description' => t('Check this to allow users to configure out of office responses.')
      );

      // external mailboxes
      $form['external_mailboxes'] = array(
      	'#type' => 'fieldset',
          '#title' => t('External Mailboxes'),
          '#collapsible' => TRUE,
          '#collapsed' => TRUE
      );

      $form['external_mailboxes']['webmail_plus_allow_external_mailboxes'] = array(
      	'#type' => 'checkbox',
          '#title' => t('Allow user-configured external mailboxes'),
          '#default_value' => variable_get('webmail_plus_allow_external_mailboxes', TRUE),
          '#description' => t('Check this to allow users to configure external mailboxes.')
      );

      $form['external_mailboxes']['webmail_plus_external_mailboxes_check_interval'] = array(
      	'#type' => 'textfield',
          '#title' => t('Check interval'),
          '#default_value' => variable_get('webmail_plus_external_mailboxes_check_interval', 30),
          '#description' => t('Set the frequency (in minutes) between mailboxes checks (depends on cron).')
      );

      $form['external_mailboxes']['webmail_plus_external_mailboxes_max_failures'] = array(
      	'#type' => 'textfield',
          '#title' => t('Maximum connection failures'),
          '#default_value' => variable_get('webmail_plus_external_mailboxes_max_failures', 5),
          '#description' => t('If the connection to the mailbox fails, it will be disabled and user notified.')
      );

      // publishing settings
      $form['publishing'] = array(
        '#type' => 'fieldset',
        '#title' => t('Publishing Settings'),
        '#collapsible' => TRUE,
        '#collapsed' => TRUE
      );


      $available_nodes_raw = node_get_types();

      if(sizeof($available_nodes_raw)>0) {
        foreach($available_nodes_raw as $available_node_id=>$available_node_info) {
          $allowed_publish_nodes[$available_node_info->name]=$available_node_info->name;
        }

        $form['publishing']['webmail_plus_allowed_publish_nodes'] = array(
        	'#type' => 'checkboxes',
        	'#title' => t('Allow publishing to these nodes'),
         	'#default_value' => variable_get('webmail_plus_allowed_publish_nodes', array()),
        	'#options' => $allowed_publish_nodes,
        	'#description' => t('Select nodes which a user can publish an email as.')
        );
      }

      return system_settings_form($form);
	}
}

?>