<?php
function webmail_plus_message_view() {
  return drupal_get_form('webmail_plus_message_view_form');
}

function webmail_plus_message_view_form() {
   require_once "webmail_plus.functions.inc";
   require_once 'webmail_plus.tag_functions.inc';

   global $user, $webmail_plus_config;


   $message_id = arg(2);

   list($uid, $message_folder, $message_uid) = split("-", $message_id);

   $mail_api_connection = webmail_plus_connect();
   //mail_api_connect($webmail_plus_config->domain, $user->name, $webmail_plus_config->password, $message_folder);

   $message_header = mail_api_header($message_uid, MAIL_API_ARRAY);

   //print_r($message_header);

   drupal_set_title(t('Message ').webmail_plus_render_subject($message_header['Subject']));


   $form['message_header'] = array(
   	'#type' => 'fieldset',
    '#title' => t('Message Header'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
   );

   $form['message_header']['from'] = array(
     '#value' => $message_header['From'],
     '#prefix' => '<pre>',
     '#suffix' => '</pre>',
   );

   $form['message_header']['to'] = array(
     '#value' => $message_header['To'],
     '#prefix' => '<pre>',
     '#suffix' => '</pre>',
   );

   $form['message_header']['date'] = array(
     '#value' => $message_header['Date'],
     '#prefix' => '<pre>',
     '#suffix' => '</pre>',
   );

   $form['message_header']['full_header'] = array(
   	'#type' => 'fieldset',
    '#title' => t('Full Header'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE
   );

   $message_header_raw = mail_api_header($message_uid);
   $form['message_header']['full_header']['header'] = array(
     '#value' => $message_header_raw,
     '#prefix' => '<pre>',
     '#suffix' => '</pre>',
   );

   $body = mail_api_body($message_uid);


   $form['message_body'] = array(
   	'#type' => 'fieldset',
    '#title' => t('Message Body'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
   );

   $form['message_body']['body'] = array(
     '#value' => $body,
     '#prefix' => '<pre>',
     '#suffix' => '</pre>',
   );


   // user settings
   $form['message_tags'] = array(
   	'#type' => 'fieldset',
    '#title' => t('Message Tags'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE
   );

   // get tags assigned to this message
   $message_tags_array = webmail_plus_get_message_tags($message_folder, $message_uid);



   if(sizeof($message_tags_array)>0) {
     $message_tags = implode(" ", $message_tags_array);

   } else {
     $message_tags = "";
   }

   $form['message_tags']['tags'] = array(
     '#type' => 'textfield',
     '#default_value' => $message_tags,
  	'#prefix' => '<div class="container-inline">',
   );

   $form['message_tags']['folder'] = array(
     '#type' => 'hidden',
     '#default_value' => $message_folder,
   );

   $form['message_tags']['message_uid'] = array(
     '#type' => 'hidden',
     '#default_value' => $message_uid,
     '#descrption' => t('Tags separated by space, comma or semicolon.')
   );

   $form['message_tags']['submit'] = array(
     '#type' => 'submit',
     '#value' => t('Update Tags'),
     '#weight' => 10,
     '#suffix' => '</div>'
      );

   // if this form is submitted it needs to be redirected
   $form_state['redirect'] = 'webmail_plus/message_view/'.$user->uid.'-'.$message_folder.'-'.$message_uid;

   return $form;
   //return drupal_render_form('webmail_plus_message_view', $form);
   //theme('webmail_plus_message_view', $form);
}

function theme_webmail_plus_message_view($form) {



  $content = form_render($form['message_header']);
  unset($form['message_header']);

  $content = form_render($form['message_body']['body']);
  unset($form['message_header']['body']);

  return $content;
}


function webmail_plus_message_view_form_submit($form, &$form_state) {
  global $user;



  require_once 'webmail_plus.tag_functions.inc';

  $tags = $form_state['values']['tags'];

  // slipt tags by comma, semicolon or space
  $tags_array = preg_split("/\s|,|;/", $tags);
  $tags_array = array_unique($tags_array);

  // handle tags if there are any
  if(sizeof($tags_array)>0) {
    //drupal_set_message('tags: '.$tags);


    // remove all tags
    webmail_plus_flush_tags($form_state['values']['folder'], $form_state['values']['message_uid']);

    // assign new tags
    foreach($tags_array as $index=>$tag) {
      $tag = strtolower(trim($tag));
      if($tag=="") continue;

      //drupal_set_message('adding tag '.$tag.' to the message '.$form_state['values']['message_uid']);

      // add new tag
      webmail_plus_add_tag($form_state['values']['folder'], $form_state['values']['message_uid'], $tag);

    }
  }
}

