<?php
// $Id: webmail_plus.view_folder.inc,v 1.1.2.3 2008/07/08 01:26:14 firmidea Exp $

function webmail_plus_view_folder($folder = 'INBOX') {

  return drupal_get_form('webmail_plus_view_folder_form');

}

function webmail_plus_view_folder_form() {
  global $webmail_plus_config;

  require_once 'webmail_plus.user.inc';
  require_once 'webmail_plus.functions.inc';

  global $user;

  $folder  = arg(2);
  if ($folder=="") {
    $folder = $webmail_plus_config->inbox_folder;
  }

  drupal_set_title(t('Folder: %folder', array('%folder'=>$folder)));

  $form['action'] = array(
    '#type' => 'fieldset',
    '#title' => t('Actions'),
    '#prefix' => '<div class="container-inline">', '#suffix' => '</div>'
  );

  $form['action']['folder'] = array(
    '#type' => 'hidden',
    '#value' => $folder
  );


  $form['action']['delete'] = array(
    '#type' => 'submit',
    '#title' => t('Delete'),
    '#value' => t('Delete')
  );

   // these should always be present
   $options['mark_read'] = t('Mark Read');
   $options['mark_unread'] = t('Mark Unread');

   // move to folder
   //$mail_api_connection = mail_api_connect($webmail_plus_config->domain, $user->name, $webmail_plus_config->password, "", $webmail_plus_config->options);

   $mail_api_connection = webmail_plus_connect();

   $mailboxes = mail_api_mailboxes();

   //print_r($mailboxes);

   if (sizeof($mailboxes)>0) {
     foreach($mailboxes as $mailbox_id => $mailbox_name) {

       // if for some reason the mailbox is empty, skip it
       if ($mailbox_name=="") continue;

       // do not show the current mailbox as an option
       if ($mailbox_name==$folder) continue;
       $options['move_to_'.$mailbox_name] = t('Move to').' '.$mailbox_name;
     }
   }

   // tag with
   require_once 'webmail_plus.tag_functions.inc';
   $user_tags = webmail_plus_get_user_tags();

   if (sizeof($user_tags)>0) {
     foreach($user_tags as $tag_id=>$tag) {
       $options['tag_with_'.$tag] = t('Tag with').' '.$tag;
     }
   }

   $form['action']['operation'] = array(
		'#type' => 'select',
		'#options' => $options,
		'#default_value' => 'suspend'
   );

   $form['action']['update'] = array(
   		'#type' => 'submit',
   		'#value' => t('Update')
   );


   $domain = variable_get('webmail_plus_connection', NULL);
   //drupal_set_message('using connection '.$domain);


  // $update = webmail_plus_update_messages();



  $form['header'] = array('#type' => 'value', '#value' => array(
    theme('table_select_header_cell'),
    array('data' => t('From'), 'field' => 'from'),
    array('data' => t('Subject'), 'field' => 'subject'),
    array('data' => t('Date'), 'field' => 'date'),
  ));


  // FIXME: need to add tablesort

  //$tablesort = tablesort_sql($form['header']);


  $sql = "SELECT * FROM {webmail_plus_user_headers} WHERE uid=".$user->uid." AND folder='".$folder."'";

  $result = pager_query($sql, 50);

  while($header = db_fetch_object($result)) {
   //print_r($header);

   $key = $user->uid."-".$folder."-".$header->message_uid;
   //echo $key."<br>\n";

   $selected[$key] = '';

   $form['from'][$key] = array('#value' => l(webmail_plus_render_from($header->from), 'webmail_plus/message_view/'.$key));
   $form['subject'][$key] = array('#value' => l(webmail_plus_render_subject($header->subject), 'webmail_plus/message_view/'.$key));
   $form['date'][$key] = array('#value' => l(webmail_plus_render_date($header->date), 'webmail_plus/message_view/'.$key));
  }

  $form['selected'] = array('#type' => 'checkboxes', '#options' => $selected);
  $form['pager'] = array('#value' => theme('pager', NULL, 50, 0));


  return $form;
}


function theme_webmail_plus_view_folder_form($form) {

  $output = drupal_render($form['action']);

  if (isset($form['from'])) {

     foreach (element_children($form['from']) as $key) {
       $row = array();

       $row[] = drupal_render($form['selected'][$key]);
       $row[] = drupal_render($form['from'][$key]);
       $row[] = drupal_render($form['subject'][$key]);
       $row[] = drupal_render($form['date'][$key]);
       $rows[] = $row;
     }

  } else {
    $rows[] = array(array('data' => t('No messages available.'), 'colspan' => '4'));
  }

  $output .= theme('table', $form['header']['#value'], $rows);

  if ($form['pager']['#value']) {
    $output .= drupal_render($form['pager']);
  }

  $output .= drupal_render($form);

  return $output;

}

/**
 * implementation of hook_submit
 *
 * @param unknown_type $form_id
 * @param unknown_type $form_state
 */
function webmail_plus_view_folder_form_submit($form_id, &$form_state) {
  //print_r($form_state);

  // go thru all the messages and apply the action
  foreach($form_state['values']['selected'] as $message_id=>$message_checked) {
    if ($message_checked==0) continue;

    list($message_user_uid, $message_folder, $message_uid) = split('-', $message_id);

    // perform drop down operations
    if ($form_state['clicked_button']['#value']==t('Update')) {
      drupal_set_message('Performing a drop-down action');
      //print_r($form_state);

      if (preg_match("/move_to_/", $form_state['values']['operation'])) {
        $folder=substr($form_state['values']['operation'], 8, strlen($form_state['values']['operation'])-8);

        drupal_set_message('moving a message to '.$folder);

      }

      if (preg_match("/tag_with_/", $form_state['values']['operation'])) {
        $tag=substr($form_state['values']['operation'], 9, strlen($form_state['values']['operation'])-9);

        //print_r($form_state);
        //drupal_set_message('tagging a message with '.$tag);

        webmail_plus_add_tag($form_state['values']['folder'], $message_uid, $tag);

      }
    }

    // handle delete action
    if ($form_state['clicked_button']['#value']==t('Delete')) {
      drupal_set_message('Performing delete');
    }


  }

}



?>
